/** Copyright (C) Marat Fayzullin 1996      **/
/**               Alex Krasivsky  1996      **/
/**               Joel Yliluoma   2000      **/

#include "cpu.hh"

BYTE Clocks[256] =
{
  7,6,2,8, 3,3,5,5, 3,2,2,2, 4,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7,
  6,6,2,8, 3,3,5,5, 4,2,2,2, 4,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7,
  
  6,6,2,8, 3,3,5,5, 3,2,2,2, 3,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7,
  6,6,2,8, 3,3,5,5, 4,2,2,2, 5,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7,
  
  2,6,2,6, 3,3,3,3, 2,2,2,2, 4,4,4,4,
  2,6,2,6, 4,4,4,4, 2,5,2,5, 5,5,5,5,
  2,6,2,6, 3,3,3,3, 2,2,2,2, 4,4,4,4,
  2,5,2,5, 4,4,4,4, 2,4,2,5, 4,4,4,4,
  
  2,6,2,8, 3,3,5,5, 2,2,2,2, 4,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7,
  2,6,2,8, 3,3,5,5, 2,2,2,2, 4,4,6,6,
  2,5,2,8, 4,4,6,6, 2,4,2,7, 5,5,7,7
};

BYTE ZNTable[256] =
{
  Z_FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
};

/** Modifying Memory *****************************************/
/** These macros calculate address and modify it.           **/
/*************************************************************/
/*
 *  Acceptable Cmds:
 *      M_ASL
 *      M_ROL
 *      M_LSR
 *      M_ROR
 *      M_INC
 *      M_DEC
 */
#define MM_Ab(Cmd)	{ register WORD J = MC_Ab(); register BYTE i = Rd6502(J); Cmd(i); Wr6502(J,i); }
#define MM_Zp(Cmd)	{ register WORD J = MC_Zp(); register BYTE i = Rd6502(J); Cmd(i); Wr6502(J,i); }
#define MM_Zx(Cmd)	{ register WORD J = MC_Zx(); register BYTE i = Rd6502(J); Cmd(i); Wr6502(J,i); }
#define MM_Ax(Cmd)	{ register WORD J = MC_Ax(); register BYTE i = Rd6502(J); Cmd(i); Wr6502(J,i); }

#define M_ASL(Rg)	M_CARRYUPD_HI(Rg); M_FL(Rg <<= 1)
#define M_LSR(Rg)	M_CARRYUPD_LO(Rg); M_FL(Rg >>= 1)
#define M_INC(Rg)	M_FL(++Rg)
#define M_DEC(Rg)	M_FL(--Rg)
#define M_ROL(Rg)	{ register BYTE k = (Rg << 1) | (P & C_FLAG); M_CARRYUPD_HI(Rg); M_FL(Rg = k); }
#define M_ROR(Rg)	{ register BYTE k = (Rg >> 1) | (P << 7);     M_CARRYUPD_LO(Rg); M_FL(Rg = k); }

void m6502cpu::Int(InterruptType Type)
{
	switch(Type)
	{
		case INT_IRQ:
			if(P & I_FLAG) { IRQPending = true; return; }
			/* Fall through */
		case INT_NMI:
        	/* Interrupt latency is 7 cycles. */
            ICount += 7;
            
            M_PUSH(PC.B.h);
            M_PUSH(PC.B.l);
            M_PUSH(P & ~B_FLAG);
            P &= ~D_FLAG;
            
            fWORD J;
            if(Type == INT_NMI)
                J = 0xFFFA;
            else
            {
                P |= I_FLAG;
                J = 0xFFFE;
            }
            PC.B.l = Op6502(J);
            PC.B.h = Op6502(J+1);
	}
}

#define M_JUMP(ehto) if(ehto) { PC.W += (SBYTE)Op6502(PC.W) + 1; ++ICount; } else ++PC.W

void m6502cpu::Tick()
{
	if(ICount) { --ICount; return; }
    switch(fetchop())
    {
        case 0x10: M_JUMP(!(P&N_FLAG)); break; /* BPL * REL */
        case 0x30: M_JUMP( (P&N_FLAG)); break; /* BMI * REL */
        case 0x50: M_JUMP(!(P&V_FLAG)); break; /* BVC * REL */
        case 0x70: M_JUMP( (P&V_FLAG)); break; /* BVS * REL */
        case 0x90: M_JUMP(!(P&C_FLAG)); break; /* BCC * REL */
        case 0xB0: M_JUMP( (P&C_FLAG)); break; /* BCS * REL */
        case 0xD0: M_JUMP(!(P&Z_FLAG)); break; /* BNE * REL */
        case 0xF0: M_JUMP( (P&Z_FLAG)); break; /* BEQ * REL */

        case 0x00: M_BRK(); break;
        case 0x40: M_RTI(); break;
        case 0x60: M_RTS(); break;
        case 0x20: PC.W = M_ABSJSR(); break; /* JSR $ssss ABS */
        case 0x4C: PC.W = M_LDWORD(); break; /* JMP $ssss ABS */
        case 0x6C: M_INDIRJMP(); break;      /* JMP ($ssss) ABDINDIR */

        case 0x08: M_PUSH(P);break;        /* PHP */
        case 0x28: M_PLP();break;          /* PLP */
        case 0x18: P&=~C_FLAG;break;       /* CLC */
        case 0x38: P|=C_FLAG;break;        /* SEC */
        case 0x58: M_CLI(); break;         /* CLI - ENABLE interrupts */
        case 0x78: P|=I_FLAG;break;        /* SEI - DISABLE interrupts */
        case 0xB8: P&=~V_FLAG;break;       /* CLV */
        case 0xD8: P&=~D_FLAG;break;       /* CLD */
        case 0xF8: P|=D_FLAG;break;        /* SED */
        case 0x48: M_PUSH(A);break;        /* PHA */
        case 0x68: M_LDA(M_POP());break;   /* PLA */
        case 0x98: M_LDA(Y);break;         /* TYA */
        case 0xA8: M_LDY(A);break;         /* TAY */
        case 0x8A: M_LDA(X);break;         /* TXA */
        case 0xAA: M_LDX(A);break;         /* TAX */
        case 0x9A: S=X;break;              /* TXS */
        case 0xBA: X=S;break;              /* TSX */
        case 0x88: M_DEC(Y);break;         /* DEY */
        case 0xCA: M_DEC(X);break;         /* DEX */
        case 0xC8: M_INC(Y);break;         /* INY */
        case 0xE8: M_INC(X);break;         /* INX */

        case 0x24: M_BIT(MR_Zp());break;   /* BIT $ss ZP */
        case 0x05: M_ORA(MR_Zp());break;   /* ORA $ss ZP */
        case 0x25: M_AND(MR_Zp());break;   /* AND $ss ZP */
        case 0x45: M_EOR(MR_Zp());break;   /* EOR $ss ZP */
        case 0x65: M_ADC(MR_Zp());break;   /* ADC $ss ZP */
        case 0xC5: M_CMP(MR_Zp(),A);break; /* CMP $ss ZP */
        case 0xE5: M_SBC(MR_Zp());break;   /* SBC $ss ZP */
        case 0xA4: M_LDY(MR_Zp());break;   /* LDY $ss ZP */
        case 0xA5: M_LDA(MR_Zp());break;   /* LDA $ss ZP */
        case 0xA6: M_LDX(MR_Zp());break;   /* LDX $ss ZP */        
        case 0xC4: M_CMP(MR_Zp(),Y);break; /* CPY $ss ZP */
        case 0xE4: M_CMP(MR_Zp(),X);break; /* CPX $ss ZP */

        case 0x2C: M_BIT(MR_Ab());break;   /* BIT $ssss ABS */
        case 0x0D: M_ORA(MR_Ab());break;   /* ORA $ssss ABS */
        case 0x2D: M_AND(MR_Ab());break;   /* AND $ssss ABS */
        case 0x4D: M_EOR(MR_Ab());break;   /* EOR $ssss ABS */
        case 0x6D: M_ADC(MR_Ab());break;   /* ADC $ssss ABS */
        case 0xCD: M_CMP(MR_Ab(),A);break; /* CMP $ssss ABS */
        case 0xED: M_SBC(MR_Ab());break;   /* SBC $ssss ABS */
        case 0xAC: M_LDY(MR_Ab());break;   /* LDY $ssss ABS */
        case 0xAD: M_LDA(MR_Ab());break;   /* LDA $ssss ABS */
        case 0xAE: M_LDX(MR_Ab());break;   /* LDX $ssss ABS */
        case 0xCC: M_CMP(MR_Ab(),Y);break; /* CPY $ssss ABS */
        case 0xEC: M_CMP(MR_Ab(),X);break; /* CPX $ssss ABS */
                
        case 0x09: M_ORA(MR_Im());break;   /* ORA #$ss IMM */
        case 0x29: M_AND(MR_Im());break;   /* AND #$ss IMM */
        case 0x49: M_EOR(MR_Im());break;   /* EOR #$ss IMM */
        case 0x69: M_ADC(MR_Im());break;   /* ADC #$ss IMM */
        case 0xC9: M_CMP(MR_Im(),A);break; /* CMP #$ss IMM */
        case 0xE9: M_SBC(MR_Im());break;   /* SBC #$ss IMM */
        case 0xA0: M_LDY(MR_Im());break;   /* LDY #$ss IMM */
        case 0xA2: M_LDX(MR_Im());break;   /* LDX #$ss IMM */
        case 0xA9: M_LDA(MR_Im());break;   /* LDA #$ss IMM */        
        case 0xC0: M_CMP(MR_Im(),Y);break; /* CPY #$ss IMM */
        case 0xE0: M_CMP(MR_Im(),X);break; /* CPX #$ss IMM */
        
        case 0x15: M_ORA(MR_Zx());break;   /* ORA $ss,x ZP,x */
        case 0x35: M_AND(MR_Zx());break;   /* AND $ss,x ZP,x */
        case 0x55: M_EOR(MR_Zx());break;   /* EOR $ss,x ZP,x */
        case 0x75: M_ADC(MR_Zx());break;   /* ADC $ss,x ZP,x */
        case 0xD5: M_CMP(MR_Zx(),A);break; /* CMP $ss,x ZP,x */
        case 0xF5: M_SBC(MR_Zx());break;   /* SBC $ss,x ZP,x */
        case 0xB4: M_LDY(MR_Zx());break;   /* LDY $ss,x ZP,x */
        case 0xB5: M_LDA(MR_Zx());break;   /* LDA $ss,x ZP,x */
        case 0xB6: M_LDX(MR_Zy());break;   /* LDX $ss,y ZP,y */        
        
        case 0x19: M_ORA(MR_Ay());break;   /* ORA $ssss,y ABS,y */
        case 0x39: M_AND(MR_Ay());break;   /* AND $ssss,y ABS,y */
        case 0x59: M_EOR(MR_Ay());break;   /* EOR $ssss,y ABS,y */
        case 0x79: M_ADC(MR_Ay());break;   /* ADC $ssss,y ABS,y */
        case 0xD9: M_CMP(MR_Ay(),A);break; /* CMP $ssss,y ABS,y */
        case 0xF9: M_SBC(MR_Ay());break;   /* SBC $ssss,y ABS,y */
        case 0xB9: M_LDA(MR_Ay());break;   /* LDA $ssss,y ABS,y */
        case 0xBE: M_LDX(MR_Ay());break;   /* LDX $ssss,y ABS,y */
        
        case 0x1D: M_ORA(MR_Ax());break;   /* ORA $ssss,x ABS,x */
        case 0x3D: M_AND(MR_Ax());break;   /* AND $ssss,x ABS,x */
        case 0x5D: M_EOR(MR_Ax());break;   /* EOR $ssss,x ABS,x */
        case 0x7D: M_ADC(MR_Ax());break;   /* ADC $ssss,x ABS,x */
        case 0xDD: M_CMP(MR_Ax(),A);break; /* CMP $ssss,x ABS,x */
        case 0xFD: M_SBC(MR_Ax());break;   /* SBC $ssss,x ABS,x */
        case 0xBC: M_LDY(MR_Ax());break;   /* LDY $ssss,x ABS,x */
        case 0xBD: M_LDA(MR_Ax());break;   /* LDA $ssss,x ABS,x */
        
        case 0x01: M_ORA(MR_Ix());break;   /* ORA ($ss,x) INDEXINDIR */
        case 0x21: M_AND(MR_Ix());break;   /* AND ($ss,x) INDEXINDIR */
        case 0x41: M_EOR(MR_Ix());break;   /* EOR ($ss,x) INDEXINDIR */
        case 0x61: M_ADC(MR_Ix());break;   /* ADC ($ss,x) INDEXINDIR */
        case 0xC1: M_CMP(MR_Ix(),A);break; /* CMP ($ss,x) INDEXINDIR */
        case 0xE1: M_SBC(MR_Ix());break;   /* SBC ($ss,x) INDEXINDIR */
        case 0xA1: M_LDA(MR_Ix());break;   /* LDA ($ss,x) INDEXINDIR */

        case 0x11: M_ORA(MR_Iy());break;   /* ORA ($ss),y INDIRINDEX */
        case 0x31: M_AND(MR_Iy());break;   /* AND ($ss),y INDIRINDEX */
        case 0x51: M_EOR(MR_Iy());break;   /* EOR ($ss),y INDIRINDEX */
        case 0x71: M_ADC(MR_Iy());break;   /* ADC ($ss),y INDIRINDEX */
        case 0xD1: M_CMP(MR_Iy(),A);break; /* CMP ($ss),y INDIRINDEX */
        case 0xF1: M_SBC(MR_Iy());break;   /* SBC ($ss),y INDIRINDEX */
        case 0xB1: M_LDA(MR_Iy());break;   /* LDA ($ss),y INDIRINDEX */

        case 0x06: MM_Zp(M_ASL);break;     /* ASL $ss ZP */
        case 0x0E: MM_Ab(M_ASL);break;     /* ASL $ssss ABS */
        case 0x16: MM_Zx(M_ASL);break;     /* ASL $ss,x ZP,x */
        case 0x1E: MM_Ax(M_ASL);break;     /* ASL $ssss,x ABS,x */
        case 0x0A: M_ASL(A);break;         /* ASL a ACC */
        
        case 0x26: MM_Zp(M_ROL);break;     /* ROL $ss ZP */
        case 0x2E: MM_Ab(M_ROL);break;     /* ROL $ssss ABS */
        case 0x36: MM_Zx(M_ROL);break;     /* ROL $ss,x ZP,x */
        case 0x3E: MM_Ax(M_ROL);break;     /* ROL $ssss,x ABS,x */
        case 0x2A: M_ROL(A);break;         /* ROL a ACC */
        
        case 0x46: MM_Zp(M_LSR);break;     /* LSR $ss ZP */
        case 0x4E: MM_Ab(M_LSR);break;     /* LSR $ssss ABS */
        case 0x56: MM_Zx(M_LSR);break;     /* LSR $ss,x ZP,x */
        case 0x5E: MM_Ax(M_LSR);break;     /* LSR $ssss,x ABS,x */
        case 0x4A: M_LSR(A);break;         /* LSR a ACC */
        
        case 0x66: MM_Zp(M_ROR);break;     /* ROR $ss ZP */
        case 0x6E: MM_Ab(M_ROR);break;     /* ROR $ssss ABS */
        case 0x76: MM_Zx(M_ROR);break;     /* ROR $ss,x ZP,x */
        case 0x7E: MM_Ax(M_ROR);break;     /* ROR $ssss,x ABS,x */
        case 0x6A: M_ROR(A);break;         /* ROR a ACC */
        
        case 0xC6: MM_Zp(M_DEC);break;     /* DEC $ss ZP */
        case 0xCE: MM_Ab(M_DEC);break;     /* DEC $ssss ABS */
        case 0xD6: MM_Zx(M_DEC);break;     /* DEC $ss,x ZP,x */
        case 0xDE: MM_Ax(M_DEC);break;     /* DEC $ssss,x ABS,x */
        
        case 0xE6: MM_Zp(M_INC);break;     /* INC $ss ZP */
        case 0xEE: MM_Ab(M_INC);break;     /* INC $ssss ABS */
        case 0xF6: MM_Zx(M_INC);break;     /* INC $ss,x ZP,x */
        case 0xFE: MM_Ax(M_INC);break;     /* INC $ssss,x ABS,x */

        case 0x84: MW_Zp(Y);break;         /* STY $ss ZP */
        case 0x85: MW_Zp(A);break;         /* STA $ss ZP */
        case 0x86: MW_Zp(X);break;         /* STX $ss ZP */

        case 0x8C: MW_Ab(Y);break;         /* STY $ssss ABS */
        case 0x8D: MW_Ab(A);break;         /* STA $ssss ABS */
        case 0x8E: MW_Ab(X);break;         /* STX $ssss ABS */

        case 0x94: MW_Zx(Y);break;         /* STY $ss,x ZP,x */
        case 0x95: MW_Zx(A);break;         /* STA $ss,x ZP,x */
        case 0x96: MW_Zy(X);break;         /* STX $ss,y ZP,y */

        case 0x99: MW_Ay(A);break;         /* STA $ssss,y ABS,y */
        case 0x9D: MW_Ax(A);break;         /* STA $ssss,x ABS,x */
        case 0x81: MW_Ix(A);break;         /* STA ($ss,x) INDEXINDIR */
        case 0x91: MW_Iy(A);break;         /* STA ($ss),y INDIRINDEX */

        case 0xEA: break;                  /* NOP */
        // Bad ops should be silently ignored like NOP.
    }
}
